
![github_readme_logo.svg](https://images.zenhubusercontent.com/5a85d50c4b5806bc2bc7186b/408ec7e2-a641-4802-a6de-b3b3ada0445d)

# FAST-DNA

An unopinionated system of components, development tools, and utilities used à la carte or as a suite to build enterprise-grade websites and applications.

[![Maintainability](https://api.codeclimate.com/v1/badges/8a74621e634a6e9b9561/maintainability)](https://codeclimate.com/github/Microsoft/fast-dna/maintainability)
[![Test Coverage](https://api.codeclimate.com/v1/badges/8a74621e634a6e9b9561/test_coverage)](https://codeclimate.com/github/Microsoft/fast-dna/test_coverage)
![workflows](https://github.com/microsoft/fast-dna/workflows/CI%20-%20FAST/badge.svg?branch=master&event=push)
[![lerna](https://img.shields.io/badge/maintained%20with-lerna-cc00ff.svg)](https://lerna.js.org/)
[![Discord](https://img.shields.io/badge/support%20with-discord-cc00ff.svg)](https://discord.gg/FcSNfg4)
[![code style: prettier](https://img.shields.io/badge/code_style-prettier-ff69b4.svg?style=flat-square)](https://github.com/prettier/prettier)
![license](https://img.shields.io/github/license/mashape/apistatus.svg)

:star: We appreciate your star, it helps!

## Key features & benefits

### Unopinionated

There are a million and one great ways to build your next website or application. To support the technologies you choose, creating unopinionated code is at the center of every decision we make in FAST-DNA.

This principle of being unopinionated manifests in several important ways including:

* A flat component architecture that lets you compose what you need without struggling with rigid patterns and complex objects.
* Separating base components and style that supports multiple frameworks without re-writing or duplicating styles. This separation also lets you build your own styles, with your styling technology of choice, without having to re-build or duplicate the base components.
* Framework agnostic tooling that lets you use our development tools with any view framework.
* The ability to replace almost any FAST-DNA package with your package of choice. Get started with our animation or layout package and add more as you need them. Alternatively, use our suite of packages to build your next project from the ground up; it's your call.

### UI development and style guide tools

When developing components and views, excellent development tooling can make all the difference. FAST-DNA offers development and style guide tools that work with FAST components, components from other frameworks, or your components.

Try out component properties with an auto-generated props UI, get a live preview of the code based on any property’s configuration, preview localization (RTL/LTR) and themes, and preview component compositing with a transparency grid.

Also, we built FAST development tools from re-usable packages so, if you have special needs, you can build your tools from the same shared libraries.

### Bring your design system

Widely available design systems from companies like Microsoft (Fluent), Google (Material), or Salesforce (Lightning) are useful when it is essential to align with a platform or take advantage of a polished system at low cost, but many companies have their design system of their own, and some may have multiple design systems or variations.

Because FAST-DNA has abstracted base components from their style, you get a head start on your design system by building on top of tried and true base components and style libraries like our offerings for color, animation, and elevation.

## Packages

FAST-DNA is a mono repository managed with [Lerna](https://github.com/lerna/lerna). Users choose à la carte which package to use in their project.

### Component Explorer
![CD Component Explorer](https://github.com/microsoft/fast-dna/workflows/CI%20Component%20Explorer/badge.svg?branch=master&event=push)

Launch our [Component Explorer](https://explore.fast.design) to experience our [Microsoft React Components](https://github.com/microsoft/fast-dna/tree/master/packages/fast-components-react-msft) package and development tools.

View the [staging site](https://fast-explore-stage.azurewebsites.net/) to see unpublished changes currently staged for release in the master branch.

## Documentation

Visit our [developer documentation](https://www.fast.design/docs/en/contributing/install) to get started.

## Troubleshooting

Experiencing problems? Check our infrastructure [health status](https://www.fast.design/docs/en/contributing/status).

## Contact

* Join the community on [Discord](https://discord.gg/FcSNfg4).
* Ask for help on [Stack Overflow](https://stackoverflow.com/questions/tagged/fast-dna).
* Submit requests and issues on [Github](https://github.com/Microsoft/fast-dna/issues/new/choose).
* Contributors, find good first issues on [Github](https://github.com/Microsoft/fast-dna/labels/good%20first%20issue).
